package com.landray.kmss.plugin.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.StringReader;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

public class XmlUtils {

   private Document root;


   public static void main(String[] args) throws Exception {
      String s = "<module><module-name>CORE</module-name><module-path>core</module-path><baseline>V13.0.0.R.20170310</baseline><source-md5>6bc470f3c635e0fc5d7fb93c071c24bd</source-md5><is-custom>N/is-custom><serial-num>0</serial-num></module>";
      XmlUtils xu = new XmlUtils(s);
      System.out.println(xu.getTextValue("baselidne"));
   }

   public XmlUtils(String xml) throws Exception {
      StringReader reader = new StringReader(xml);

      try {
         this.init(new InputSource(reader));
      } finally {
         reader.close();
      }

   }

   public XmlUtils(File xmlFile) throws Exception {
      FileInputStream fis = new FileInputStream(xmlFile);

      try {
         this.init(new InputSource(fis));
      } finally {
         fis.close();
      }

   }

   private void init(InputSource is) throws Exception {
      DocumentBuilder docBuild = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      this.root = docBuild.parse(is);
   }

   public String getTextValue(String nodeName) {
      NodeList nList = this.root.getElementsByTagName(nodeName);
      if(nList != null) {
         Node item = nList.item(0);
         if(item != null) {
            String textContent = item.getTextContent();
            return textContent;
         }
      }

      return null;
   }
}
